DL_PrivateKey_GFP< GP > Class Template Reference

DL private key (in GF(p) groups) More...

Inheritance diagram for DL_PrivateKey_GFP< GP >:

## Public Member Functions

void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits)
void | Initialize (RandomNumberGenerator &rng, const Integer &p, const Integer &g)
void | Initialize (RandomNumberGenerator &rng, const Integer &p, const Integer &q, const Integer &g)
void | Initialize (const DL_GroupParameters_IntegerBased &params, const Integer &x)
void | Initialize (const Integer &p, const Integer &g, const Integer &x)
void | Initialize (const Integer &p, const Integer &q, const Integer &g, const Integer &x)
Public Member Functions inherited from DL_PrivateKeyImpl< GP >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters. More...
const Integer & | GetPrivateExponent () const
void | SetPrivateExponent (const Integer &x)
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| decode privateKey part of privateKeyInfo, without the OCTET STRING header
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| encode privateKey part of privateKeyInfo, without the OCTET STRING header
Public Member Functions inherited from DL_PrivateKey< GP::Element >
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
void | AssignFrom (const NameValuePairs &source)
virtual const Integer & | GetPrivateExponent () const=0
Public Member Functions inherited from DL_Key< GP::Element >
virtual const DL_GroupParameters< GP::Element > & | GetAbstractGroupParameters () const=0
| Retrieves abstract group parameters. More...
Public Member Functions inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()
Public Member Functions inherited from PKCS8PrivateKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
virtual OID | GetAlgorithmID () const =0
| Retrieves the OID of the algorithm. More...
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| decode optional attributes including context-specific tag More...
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| encode optional attributes including context-specific tag
Public Member Functions inherited from ASN1CryptoMaterial< PrivateKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members

Public Types inherited from DL_PrivateKeyImpl< GP >
typedef GP::Element | Element
Public Types inherited from DL_PrivateKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
typedef GP | GroupParameters
Static Public Member Functions inherited from NameValuePairs
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

### template<class GP>
class DL_PrivateKey_GFP< GP >

DL private key (in GF(p) groups)

Definition at line 275 of file gfpcrypt.h.

The documentation for this class was generated from the following file:

- gfpcrypt.h